commit 9536defc5cb25beeb00491f6b00c454aadfdb7a5
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue Dec 2 22:59:04 2025 +0000

    SPF: logging

diff --git a/src/src/functions.h b/src/src/functions.h
index 76bc24c1b..873b8c8be 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -107,6 +107,7 @@ extern uschar *acl_standalone_setvar(const uschar *, BOOL);
 extern tree_node *acl_var_create(const uschar *);
 extern void    acl_var_write(uschar *, uschar *, void *);
 extern void    add_driver_info(driver_info **, const driver_info *, size_t);
+extern gstring * add_spf_info_for_log(gstring *);
 
 extern void    assert_no_variables(void *, int, const char *, int);
 extern void    atrn_handle_customer(void);
diff --git a/src/src/globals.c b/src/src/globals.c
index 38fdbc7a3..be5afe736 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -1021,6 +1021,10 @@ bit_table log_options[]        = { /* must be in alphabetical order,
   BIT_TABLE(L, smtp_no_mail),
   BIT_TABLE(L, smtp_protocol_error),
   BIT_TABLE(L, smtp_syntax_error),
+#ifdef EXIM_HAVE_SPF
+  BIT_TABLE(L, spf),
+  BIT_TABLE(L, spf_verbose),
+#endif
   BIT_TABLE(L, subject),
   BIT_TABLE(L, tls_certificate_verified),
   BIT_TABLE(L, tls_cipher),
diff --git a/src/src/macros.h b/src/src/macros.h
index c0900eee9..ad5d73267 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -453,7 +453,7 @@ enum logbit {
   LOG_BIT(dnslist_defer),
   LOG_BIT(etrn),
   LOG_BIT(host_lookup_failed),
-  LOG_BIT(lost_incoming_connection),
+  LOG_BIT(lost_incoming_connection),	/* 7 */
   LOG_BIT(queue_run),
   LOG_BIT(retry_defer),
   LOG_BIT(size_reject),
@@ -461,7 +461,7 @@ enum logbit {
   LOG_BIT(smtp_connection),
   LOG_BIT(smtp_incomplete_transaction),
   LOG_BIT(smtp_protocol_error),
-  LOG_BIT(smtp_syntax_error),
+  LOG_BIT(smtp_syntax_error),		/* 15 */
 
   Li_8bitmime = BITWORDSIZE,
   Li_acl_warn_skipped,
@@ -497,6 +497,8 @@ enum logbit {
   Li_smtp_confirmation,
   Li_smtp_mailauth,
   Li_smtp_no_mail,
+  Li_spf,
+  Li_spf_verbose,
   Li_subject,
   Li_tls_certificate_verified,
   Li_tls_cipher,
diff --git a/src/src/receive.c b/src/src/receive.c
index 0f407ce93..a0fcffd06 100644
--- a/src/src/receive.c
+++ b/src/src/receive.c
@@ -1361,6 +1361,21 @@ DEBUG(D_receive|D_acl) debug_printf_indent(">>\n");
 *       Add host information for log line        *
 *************************************************/
 
+gstring *
+add_spf_info_for_log(gstring * g)
+{
+#ifdef EXIM_HAVE_SPF
+if (LOGGING(spf_verbose))
+  {
+  const uschar * s = expand_string(CUS"$spf_result");
+  if (*s) g = string_append(g, 2, US" SPF=", s);
+  }
+else if (LOGGING(spf) && Ustrcmp(expand_string(CUS"$spf_result"), "pass") == 0)
+  g = string_catn(g, US" SPF", 4);
+#endif
+return g;
+}
+
 /* Called for acceptance and rejecting log lines. This adds information about
 the calling host to a string that is being built dynamically.
 
@@ -1407,6 +1422,8 @@ if (LOGGING(pipelining) && f.smtp_in_pipelining_advertised)
   if (!f.smtp_in_pipelining_used)
     g = string_catn(g, US"-", 1);
   }
+
+g = add_spf_info_for_log(g);
 return g;
 }
 
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index 674bdd785..6cfc36f7a 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -3166,7 +3166,7 @@ switch (where)
 #ifdef WITH_CONTENT_SCAN
   case ACL_WHERE_MIME:
 #endif
-    sender_info = string_sprintf("F=<%s>%s%s%s%s ",
+    sender_info = string_sprintf(" F=<%s>%s%s%s%s",
       sender_address_unrewritten ? sender_address_unrewritten : sender_address,
       sender_host_authenticated ? US" A="                                    : US"",
       sender_host_authenticated ? sender_host_authenticated                  : US"",
@@ -3266,18 +3266,23 @@ is closing if required and return 2.  */
 if (log_reject_target)
   {
 #ifndef DISABLE_TLS
-  gstring * g = add_tls_info_for_log(NULL);
-  uschar * tls = string_from_gstring(g);
-  if (!tls) tls = US"";
+  gstring * tls = add_tls_info_for_log(NULL);
 #else
-  uschar * tls = US"";
+  gstring * tls = NULL;
 #endif
+#ifdef EXIM_HAVE_SPF
+  gstring * spf= add_spf_info_for_log(NULL);
+#else
+  gstring * spf = NULL;
+#endif
+
   log_write(where == ACL_WHERE_CONNECT ? L_connection_reject : 0,
-    log_reject_target, "%s%s%s %s%srejected %s%s",
+    log_reject_target, "%s%s%#Y%s%#Y %srejected %s%s",
     LOGGING(dnssec) && sender_host_dnssec ? US" DS" : US"",
     host_and_ident(TRUE),
     tls,
     sender_info,
+    spf,
     rc == FAIL ? US"" : US"temporarily ",
     what, log_msg);
   }

